---
title: MediaStreamAudioSourceNode
slug: Web/API/MediaStreamAudioSourceNode
tags:
  - API
  - Audio
  - AudioNode
  - Interface
  - Media
  - MediaStream
  - MediaStreamAudioSourceNode
  - MediaStreamTrack
  - Reference
  - Web
  - Web Audio API
  - WebRTC
  - getusermedia
  - sound
  - stream
  - track
---
<div>{{APIRef("Web Audio API")}}</div>

<div>
<p><span class="seoSummary">The <strong><code>MediaStreamAudioSourceNode</code></strong> interface is a type of {{domxref("AudioNode")}} which operates as an audio source whose media is received from a {{domxref("MediaStream")}} obtained using the WebRTC or Media Capture and Streams APIs.</span> This media could be from a microphone (through {{domxref("MediaDevices.getUserMedia", "getUserMedia()")}}) or from a remote peer on a WebRTC call (using the {{domxref("RTCPeerConnection")}}'s audio tracks).</p>
</div>

<p>A <code>MediaStreamAudioSourceNode</code> has no inputs and exactly one output, and is created using the {{domxref("AudioContext.createMediaStreamSource()")}} method.</p>

<p>The <code>MediaStreamAudioSourceNode</code> takes the audio from the <em>first</em> {{domxref("MediaStreamTrack")}} whose {{domxref("MediaStreamTrack.kind", "kind")}} attribute's value is <code>audio</code>. See {{anch("Track ordering")}} for more information about the order of tracks.</p>

<p>The number of channels output by the node matches the number of tracks found in the selected audio track.</p>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Number of inputs</th>
   <td><code>0</code></td>
  </tr>
  <tr>
   <th scope="row">Number of outputs</th>
   <td><code>1</code></td>
  </tr>
  <tr>
   <th scope="row">Channel count</th>
   <td>defined by the first audio {{domxref("MediaStreamTrack")}} passed to the {{domxref("AudioContext.createMediaStreamSource()")}} method that created it.</td>
  </tr>
 </tbody>
</table>

<h2 id="Constructor">Constructor</h2>

<dl>
 <dt>{{domxref("MediaStreamAudioSourceNode.MediaStreamAudioSourceNode", "new MediaStreamAudioSourceNode()")}}</dt>
 <dd>Creates a new <code>MediaStreamAudioSourceNode</code> object instance with the specified options.</dd>
</dl>

<h2 id="Properties">Properties</h2>

<p><em>In addition to the following properties, <code>MediaStreamAudioSourceNode</code> inherits the properties of its parent, {{domxref("AudioNode")}}.</em></p>

<dl>
 <dt>{{domxref("MediaStreamAudioSourceNode.mediaStream", "mediaStream")}} {{ReadOnlyInline}}</dt>
 <dd>The {{domxref("MediaStream")}} used when constructing this <code>MediaStreamAudioSourceNode</code>.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<p><em>Inherits methods from its parent, </em><em>{{domxref("AudioNode")}}</em>.</p>

<h2 id="Exceptions">Exceptions</h2>

<dl>
 <dt><code>InvalidStateError</code></dt>
 <dd>The stream specified by the <code>mediaStream</code> parameter does not contain any audio tracks.</dd>
</dl>

<h2 id="Usage_notes">Usage notes</h2>

<p>Typically, you should probably not use this type of node. It has been replaced with the more predictable {{domxref("MediaStreamTrackAudioSourceNode")}}, which has better-defined rules for how it chooses the track to output.</p>

<p>If you do chooose to use <code>MediaStreamAudioSourceNode</code>, you should keep the following in mind.</p>

<h3 id="Track_ordering">Track ordering</h3>

<p>For the purposes of the <code>MediaStreamTrackAudioSourceNode</code> interface, the order of the audio tracks on the stream is determined by taking the tracks whose {{domxref("MediaStreamTrack.kind", "kind")}} is <code>audio</code>, then sorting the tracks by their {{domxref("MediaStreamTrack.id", "id")}} property's values, in Unicode code point order (essentially, in alphabetical or lexicographical order, for IDs which are simple alphanumeric strings).</p>

<p>The <strong>first</strong> track, then, is the track whose <code>id</code> comes first when the tracks' IDs are all sorted by Unicode code point.</p>

<p>However, it's important to note that the rule establishing this ordering was added long after this interface was first introduced into the <a href="/en-US/docs/Web/API/Web_Audio_API">Web Audio API</a>. As such, you can't easily rely on the order matching between any two browsers or browser versions. This is why it is typically wiser to use {{domxref("MediaStreamTrackAudioSourceNode")}}, which provides similar capabilities but was better-defined upon being added to the specification, so it's more reliable.</p>

<h2 id="Example">Example</h2>

<p>{{page("/en-US/docs/Web/API/AudioContext.createMediaStreamSource","Example")}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Web Audio API', '#mediastreamaudiosourcenode', 'MediaStreamAudioSourceNode')}}</td>
   <td>{{Spec2('Web Audio API')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.MediaStreamAudioSourceNode")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Web_Audio_API/Using_Web_Audio_API">Using the Web Audio API</a></li>
 <li><a href="/en-US/docs/Web/API/WebRTC_API">WebRTC API</a></li>
 <li><a href="/en-US/docs/Web/API/Media_Streams_API">Media Capture and Streams API (Media Streams)</a></li>
 <li>{{domxref("MediaStreamTrackAudioSourceNode")}}</li>
</ul>
